unit DataModule;

interface

uses
  System.SysUtils, System.Classes, GraphQL.Comp.Schema, GraphQL.Schema;

type
  TDataModule1 = class(TDataModule)
    GraphQLSchema1: TGraphQLSchema;
    procedure DataModuleCreate(Sender: TObject);
    procedure GraphQLSchema1InitSchema(Sender: TObject; Schema: TSchemaDocument);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataModule1: TDataModule1;

implementation

uses
  System.Rtti;

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

const
  Schema =
    'type Example {                                  ' + sLineBreak +
    '  id: ID!                                       ' + sLineBreak +
    '  someInt: Int                                  ' + sLineBreak +
    '}                                               ' + sLineBreak +
    'type Query {                                    ' + sLineBreak +
    '  Example: Example!                             ' + sLineBreak +
    '}';


type
  TExample = class
  private
    FId: Integer;
    function GetSomeInt: TValue;
  public
    constructor Create;
    property Id: Integer read FId;
    property SomeInt: TValue read GetSomeInt;
  end;

  TQuery = class
    function Example: TExample;
  end;


procedure TDataModule1.DataModuleCreate(Sender: TObject);
begin
  GraphQLSchema1.Definition.Text := Schema;
end;

procedure TDataModule1.GraphQLSchema1InitSchema(Sender: TObject; Schema: TSchemaDocument);
begin
  Schema.Bind('Query', TQuery);
  Schema.Bind('Example', TExample);
end;

{ TExample }

constructor TExample.Create;
begin
  inherited Create;
  FId := 1;
end;

function TExample.GetSomeInt: TValue;
begin
  Result := TValue.Empty;
end;

{ TQuery }

function TQuery.Example: TExample;
begin
  Result := TExample.Create;
end;

end.
